property ScrollThumbSprite, DownMember, button_active

on getPropertyDescriptionList
  description = [:]
  if the currentSpriteNum = 0 then
    memdefault = 0
  else
    memref = the member of sprite the currentSpriteNum
    castLibNum = memref.castLibNum
    memdefault = member(memref.memberNum + 1, castLibNum)
  end if
  addProp(description, #DownMember, [#default: memdefault, #format: #bitmap, #comment: "Pict for Down:"])
  addProp(description, #ScrollThumbSprite, [#default: the currentSpriteNum - 1, #format: #integer, #comment: "Sprite Number of Thumb:"])
  return description
end

on getBehaviorDescription
  return "Vertical Multiline Textfield Scroll Up Button"
end

on getAssocMembers
  myPropList = [DownMember]
  return myPropList
end

on endSprite me
  puppetSprite(me.spriteNum, 0)
end

on mouseUp me
  me.button_active = 0
  swap_members(me)
  sendSprite(me.ScrollThumbSprite, #scroll_a_line, 1)
end

on mouseUpOutSide me
  me.button_active = 0
end

on mouseDown me
  swap_members(me)
  me.button_active = 1
  startTimer()
end

on mouseLeave me
  if me.button_active then
    swap_members(me)
  end if
end

on mouseEnter me
  if me.button_active then
    swap_members(me)
    startTimer()
  end if
end

on exitFrame me
  if me.button_active then
    if the timer > 30 then
      sendSprite(me.ScrollThumbSprite, #scroll_a_line, 1)
    end if
  end if
end

on swap_members me
  puppetSprite(me.spriteNum, 1)
  temp = the member of sprite me.spriteNum
  set the member of sprite the spriteNum of me to member(me.DownMember)
  me.DownMember = temp
end
