property windowLeft, windowTop, windowWidth, windowHeight, windowMovie, windowName, windowType, scrollable, sizable, zoomable, invisible, whichevent, mark

on initOpenMIAW me
  init(me)
end

on mouseUp me
  if whichevent = #mouseUp then
    init(me)
  end if
  window(windowName).title = mark
end

on prepareFrame me
  if whichevent = #prepareFrame then
    init(me)
  end if
end

on exitFrame me
  if whichevent = #exitFrame then
    init(me)
  end if
end

on init me
  w = get_previous_instance(the windowList, me.windowName)
  if objectp(w) then
    forget(w)
  end if
  if me.windowName <> EMPTY then
    w = window(me.windowName)
    w.titleVisible = 1
  else
    w = window("temp")
    w.titleVisible = 0
  end if
  w.fileName = get_filename(me.windowMovie)
  w.windowType = get_window_style(me)
  w.rect = rect(the stageLeft, the stageTop, the stageLeft + 640, the stageTop + 480)
  put w.rect
  open(w)
end

on get_previous_instance w_list, w_name
  i = count(w_list)
  repeat while i >= 1
    w = getAt(w_list, i)
    if w.name = w_name then
      return w
    end if
    i = -1 + i
  end repeat
  return -1
end

on get_window_style me
  case me.windowType of
    #Document:
      if me.zoomable then
        if me.sizable then
          t = 8
        else
          t = 12
        end if
      else
        if me.sizable then
          t = 0
        else
          t = 4
        end if
      end if
    #palette:
      t = 49
    #Rounded:
      t = 16
    #plain:
      t = 2
    #shadow:
      t = 3
    "Modal Dialog":
      t = 1
    "Movable Modal Dialog":
      t = 5
    otherwise:
      t = 4
  end case
  return t
end

on get_filename f_name
  if not (f_name contains ".dir") then
    f_name = f_name & ".dir"
  end if
  if (f_name contains "/") or (f_name contains "\") then
    if not f_name contains ":" then
      f_name = the pathname & f_name
    end if
  end if
  return f_name
end

on getPropertyDescriptionList
  p_list = [#windowMovie: [#comment: "Movie Name:", #format: #string, #default: EMPTY], #windowName: [#comment: "Window Name:", #format: #string, #default: EMPTY], #windowType: [#comment: "Window Style:", #format: #symbol, #range: [#Document, #palette, #Rounded, #plain, #shadow, "Modal Dialog", "Movable Modal Dialog"], #default: #Document], #sizable: [#comment: "Resize Box:", #format: #boolean, #default: 0], #windowLeft: [#comment: "Left:", #format: #integer, #default: 100], #windowTop: [#comment: "Top:", #format: #integer, #default: 100], #windowWidth: [#comment: "Width:", #format: #integer, #default: 0], #windowHeight: [#comment: "Height:", #format: #integer, #default: 0], #zoomable: [#comment: "Zoom Box:", #format: #boolean, #default: 0], #whichevent: [#comment: "Initializing Event:", #format: #symbol, #range: [#mouseUp, #prepareFrame, #exitFrame, #initOpenMIAW], #default: #mouseUp], #mark: [#comment: "Marker:", #format: #string, #default: EMPTY]]
  return p_list
end

on getBehaviorDescription
  return "Opens a Director movie in a window of the designated type. This behavior can be triggered by a specified event or by receiving the initOpenMIAW message. If width and height parameters are set to 0 (the default), the movie opens at it's original size." & RETURN & "PARAMETERS:" & RETURN & "• Movie Name - Enter the file name of the movie to be opened." & RETURN & "• Window Name - ( optional ) Enter the label to be displayed in window header, when visible." & RETURN & "• Window Style - Choose a border style and interactivity options. The choices are: Document (moveable, sizeable window without a zoom box), Palette (floating palette), Rounded (rounded corners), Plain (plain box, no title bar), Shadowed (plain box with shadow, no title bar), Modal Dialog, and Moveable Modal Dialog " & RETURN & "• Resize Box - Turn this option on to make the window resizable when appropriate." & RETURN & "• Left, Top - Enter the initial offset ( in pixels ) of the window from the upper left corner of the display." & RETURN & "• Width, Height - ( optional ) Enter the initial dimensions ( in pixels ) of the window." & RETURN & "• Zoom Box - Turn this option on to add a minimize/maximize button to the title bar when appropriate." & RETURN & "• Initializing Event - Choose the event that triggers the behavior. Choose initOpenMIAW to make the behavior run when it receives this message."
end
