property DownSnd, UpSnd, Action, WhichLabel, standardImage, alternateImage

on mouseDown
  click(DownSnd, UpSnd)
  if Action = "Go to marker" then
    go(WhichLabel)
  else
    if Action = "Play marker" then
      play frame WhichLabel
    end if
  end if
end

on beginSprite me
  me.standardImage = the member of sprite me.spriteNum
  memref = the member of sprite the currentSpriteNum
  castLibNum = memref.castLibNum
  alternateImage = member(memref.memberNum + 1, castLibNum)
end

on mouseEnter me
  set the member of sprite the spriteNum of me to me.alternateImage
  set the memberNum of sprite (the spriteNum of me - 1) to the memberNum of sprite (me.spriteNum - 1) + 1
end

on mouseLeave me
  if the mouseUp then
    set the member of sprite the spriteNum of me to me.standardImage
    set the memberNum of sprite (the spriteNum of me - 1) to the memberNum of sprite (me.spriteNum - 1) - 1
  end if
end

on getPropertyDescriptionList
  global ibcDefaultParams
  if the currentSpriteNum = 0 then
    memdefault = 0
  else
    memref = the member of sprite the currentSpriteNum
    castLibNum = memref.castLibNum
    memdefault = member(memref.memberNum + 1, castLibNum)
  end if
  if listp(ibcDefaultParams) then
    return ibcDefaultParams
  else
    description = [:]
    addProp(description, #Action, [#default: "None", #range: ["None", "Go to marker", "Play marker"], #format: #symbol, #comment: "MouseUp Action:"])
    addProp(description, #WhichLabel, [#comment: "Destination Marker:", #format: #marker, #default: "next"])
    return description
  end if
end

on getBehaviorDescription
  return "- Click Behavior -" & RETURN & "Defined: controls a dual-image button." & RETURN & "Intended Use: to give user a simple audio + visual feedback that they've engaged a control. Rolling off button during mouseDown will disengage." & RETURN & RETURN & "- Properties -" & RETURN & "Down Sound: assigns a mouseDown button sound." & RETURN & "Up Sound: assigns a mouseUp button sound." & RETURN & "MouseUp Action: assigns a button course of action." & RETURN & "  (Note: Select 'None' if you plan to add a seperate mouseUp behavior to this button)" & RETURN & "Destination Marker: assigns a destination to the course of action." & RETURN & RETURN & "(Explore the 'LookHere' folder on the CD-Rom for examples of each behavior)"
end

on click
  emem = the memberNum of sprite clickOn()
  updateStage()
  set the memberNum of sprite clickOn() to emem + 1
  updateStage()
  repeat while the stillDown
    if rollover(clickOn()) then
      set the memberNum of sprite clickOn() to emem + 1
    else
      set the memberNum of sprite clickOn() to emem - 1
    end if
    updateStage()
  end repeat
  set the memberNum of sprite clickOn() to emem
  updateStage()
end
